//*****************************************************************************
//*
//*
//*		FileCompare.cpp.
//*
//*
//*****************************************************************************
//
//	Copyright  2006	Anton Zechner
//
//	Parameter:	-N		Kein Tilel
//				-H		Horizontale Teilung
//				-V		Vertikale Teilung
//				-J		Zum ersten Unterschied springen
//				-I		Dateien automatisch im Intel-Hex-Format laden
//				-I1		Erste  Datei im Intel-Hex-Format laden
//				-I2		Zweite Datei im Intel-Hex-Format laden
//				-0		Nchste Datei an den ffnen Dialog senden
//				-0:???	Datei an den ffnen Dialog senden
//				-1:???	Titel fr Datei 1
//				-2:???	Titel fr Datei 2
//
#include "StdAfx.h"
#include "FileCompare.h"
#include "FileCompareDoc.h"
#include "FileCompareView.h"
#include "TaskbarTools.h"
#include "MainFrm.h"
#include "OpenDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CFileCompareApp, CWinApp)
	//{{AFX_MSG_MAP(CFileCompareApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Dateibasierte Standard-Dokumentbefehle
END_MESSAGE_MAP()


// Das einzige CFileCompareApp-Objekt
CFileCompareApp theApp;

WAPP_FUNC(CFileCompareApp)



//*****************************************************************************
//*
//*		Klasse CMyDocTemplate
//*
//*****************************************************************************
class CMyDocTemplate : public CSingleDocTemplate
	{
	public:

	BOOL	m_bFirst;
	CMyDocTemplate(UINT nIDResource, CRuntimeClass* pDocClass,CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass);
	virtual CDocument *OpenDocumentFile(LPCTSTR pPathName,BOOL bMakeVisible=TRUE);
	};

CMyDocTemplate::CMyDocTemplate(UINT nIDResource,CRuntimeClass *pDocClass,CRuntimeClass *pFrameClass,CRuntimeClass *pViewClass) : CSingleDocTemplate(nIDResource,pDocClass,pFrameClass,pViewClass)
	{
	m_bFirst = 0;	
	};


CDocument *CMyDocTemplate::OpenDocumentFile(LPCTSTR pPathName,BOOL bMakeVisible)
	{
	if(!m_bFirst)
		{
		m_bFirst = TRUE;
		bMakeVisible = FALSE;
		}

	return CSingleDocTemplate::OpenDocumentFile(pPathName,bMakeVisible);
	}


//*****************************************************************************
//*
//*		EnumWindowsProc
//*
//*****************************************************************************
static BOOL CALLBACK EnumWindowsProc(HWND hWnd,LPARAM lParam)
{
unsigned	uUser;


	   uUser = GetWindowLong(hWnd,GWL_USERDATA);
	if(uUser!=OPEN_USER)return TRUE;

	PostMessage(hWnd,OPEN_ID,0,0);

	SetWindowPos(hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);


return FALSE;
}

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
// CFileCompareApp Konstruktion
CFileCompareApp::CFileCompareApp()
{
}



//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
// CFileCompareApp Initialisierung
BOOL CFileCompareApp::InitInstance()
{
CRegKeys			sKey;
CString				sPath;
CString				sTitle[2];
CString				sFiles[2];
CCommandLineInfo	sInfo;
CFileCompareDoc	   *pDoc;
CFileCompareView   *pView;
char			   *pParam;
int					iIntelAuto=-1;
BOOL				bIntel1=FALSE;
BOOL				bIntel2=FALSE;
BOOL			    bJumpTo=FALSE;
BOOL			    bOpenDlg=FALSE;
BOOL			    bTitleOn=TRUE;
int					iViewMode=-1;
int					iFileNr=0;
int					iNext=0;
int					iErr;
int					i;


	AfxUtilityInit();
	AfxEnableControlContainer();


	#ifdef _AFXDLL
	Enable3dControls();
	#else
	Enable3dControlsStatic();
	#endif

	SetRegistryKey(_T("AZ"));
	LoadStdProfileSettings(9);


	for(i=1;i<__argc;i++)								// Argumente parsen
		{
		pParam=__targv[i];

		if(pParam[0]!='-' && pParam[0]!='/')
			{
			if(iNext)
				{
				sPath = pParam;
				iNext = 0;
				}
			else if(iFileNr<2)
				{
				sFiles[iFileNr]=pParam;
				iFileNr++;
				}
			continue;
			}

		if(pParam[1]=='I' || pParam[1]=='i')
			{
			if(pParam[2]== 0 )iIntelAuto=TRUE;
			if(pParam[2]=='1')bIntel1   =TRUE;
			if(pParam[2]=='2')bIntel2   =TRUE;
			continue;
			}

		if(pParam[1]=='N' || pParam[1]=='n')
			{
			bTitleOn=FALSE;
			continue;
			}

		if(pParam[1]=='J' || pParam[1]=='j')
			{
			bJumpTo=TRUE;
			continue;
			}

		if(pParam[1]=='H' || pParam[1]=='h')
			{
			iViewMode=TRUE;
			continue;
			}

		if(pParam[1]=='V' || pParam[1]=='v')
			{
			iViewMode=FALSE;
			continue;
			}

		if(pParam[1]=='0' && pParam[2]== 0 )
			{
			bOpenDlg=TRUE;
			iNext = 1;
			continue;
			}

		if(pParam[1]=='0' && pParam[2]==':')
			{
			bOpenDlg=TRUE;
			sPath=pParam+3;
			continue;
			}

		if(pParam[1]=='1' && pParam[2]==':')
			{
			sTitle[0]=pParam+3;
			continue;
			}

		if(pParam[1]=='2' && pParam[2]==':')
			{
			sTitle[1]=pParam+3;
			continue;
			}
		}


	if(bOpenDlg)
		{
		if(!EnumWindows(EnumWindowsProc,(LPARAM)((LPCSTR)sPath)))
			{


			if(iFileNr<2)
				{
				sKey.Open();
				sKey.Up("Messages");
				sKey.Get(sFiles[iFileNr],"Path");
				if(sFiles[iFileNr]!="")iFileNr++;
				}

			if(sPath!="" && iFileNr<2)
				{
				sFiles[iFileNr] = sPath;
				iFileNr++;
				}
			}
		else{
			COpenDlg	sDlg;

			sKey.Open();
			sKey.Up("Messages");
			sKey.Set(sPath,"Path");

			sDlg.m_sPath1		  = sPath;
			sDlg.m_bEnableReceive = TRUE;

			if(sDlg.DoModal()!=IDOK)return FALSE;

			iFileNr=0;

			if(sDlg.m_sPath1!=""            ){sFiles[0]=sDlg.m_sPath1; iFileNr++;}
			if(sDlg.m_sPath2!="" &&  iFileNr){sFiles[1]=sDlg.m_sPath2; iFileNr++;}
			if(sDlg.m_sPath2!="" && !iFileNr){sFiles[0]=sDlg.m_sPath2; iFileNr++;}
			}
		}




	pDocTemplate = new CMyDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CFileCompareDoc),
		RUNTIME_CLASS(CMainFrame),
		RUNTIME_CLASS(CFileCompareView));
	AddDocTemplate(pDocTemplate);

	// DDE-Execute-Open aktivieren
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	ParseCommandLine(sInfo);
	if(!ProcessShellCommand(sInfo))return FALSE;


	pDoc =(CFileCompareDoc *)GetDocument();
	pView=(CFileCompareView*)GetView();

	pView->SetJumpMode (bJumpTo );
	pView->SetTitleMode(bTitleOn);

					 pView->SetLoadMode(bIntel1,bIntel2,iIntelAuto);
	if(iViewMode>= 0)pView->SetViewMode(iViewMode);
	if(sTitle[0]!="")pView->SetTitle(0,sTitle[0]);
	if(sTitle[1]!="")pView->SetTitle(1,sTitle[1]);


	if(iFileNr>=2)
		{
		iErr = 0;

		if(ExistFile(sFiles[0])!=1)
			{
			CString	sText;
			sText.Format("Die Datei %s existiert nicht zum Vergleichen !",(LPCSTR)sFiles[0]);
			m_pMainWnd->MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			iErr=1;
			}

		if(ExistFile(sFiles[1])!=1)
			{
			CString	sText;
			sText.Format("Die Datei %s existiert nicht zum Vergleichen !",(LPCSTR)sFiles[1]);
			m_pMainWnd->MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			iErr=2;
			}

		if(!iErr)
			{
			   iErr=pView->OpenFiles(sFiles[0],sFiles[1]);
			if(iErr>=1 && iErr<=2)
				{
				CString	sText;
				sText.Format("Die Datei %s konnte nicht geffnet werden !",(LPCSTR)sFiles[iErr-1]);
				m_pMainWnd->MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
				}
			}
		}


	m_pMainWnd->SetWindowText("FileCompare");
	m_pMainWnd->UpdateWindow();

	if(__argc<=1)
		{
		m_pMainWnd->ShowWindow(SW_HIDE);
		m_pMainWnd->PostMessage(WM_COMMAND,ID_FILE_OPEN);
		TaskbarShow(m_pMainWnd->m_hWnd);
		}
	else{
		m_pMainWnd->ShowWindow(SW_SHOW);
		}



return TRUE;
}





//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
// Anwendungsbefehl zum Ausfhren des Dialogfelds
void CFileCompareApp::OnAppAbout()
{
	CDialog	aboutDlg(IDD_ABOUTBOX);
	aboutDlg.DoModal();
}

