//*****************************************************************************
//*
//*		
//*		FileCompareView.cpp : Implementierung der Klasse CFileCompareView
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"FileCompare.h"
#include	"FileCompareDoc.h"
#include	"FileCompareView.h"
#include	"HexFind.h"
#include	"OpenDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_HEXWND		0x1002
#define 	 MARGIN_SIZE	12



IMPLEMENT_DYNCREATE(CFileCompareView, CView)

BEGIN_MESSAGE_MAP(CFileCompareView, CView)
	//{{AFX_MSG_MAP(CFileCompareView)
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_FILE_OPEN				  ,OnOpenFiles)
	ON_COMMAND(ID_CPP_COPY				  ,OnCppCopy)
	ON_COMMAND(ID_CHECKSUM				  ,OnChecksum)
	ON_COMMAND(ID_EDIT_COPY				  ,OnCopy)
	ON_COMMAND(ID_HEX_CONFIG  			  ,OnConfigView)
	ON_COMMAND(ID_EDIT_FIND   			  ,OnFindView)
	ON_COMMAND(ID_EDIT_FIND_NEXT		  ,OnFindNext)
	ON_COMMAND(ID_EDIT_FIND_NEXT2		  ,OnFindMark)
	ON_COMMAND(ID_RELOAD				  ,OnReload)
	ON_COMMAND(ID_MOVETO				  ,OnMoveTo)
	ON_COMMAND(ID_VIEW_FONT				  ,OnFontView)
	ON_COMMAND(ID_VIEW_COLOR			  ,OnColorView)
	ON_COMMAND(ID_HEX_CONVERT			  ,OnHexConvert)	
	ON_COMMAND(ID_VIEWMODE				  ,OnViewMode)	
	ON_COMMAND(ID_FIRST					  ,OnFirst)
	ON_COMMAND(ID_LAST					  ,OnLast)
	ON_COMMAND(ID_UP					  ,OnUp)
	ON_COMMAND(ID_DOWN					  ,OnDown)
	ON_COMMAND(ID_CURRENT				  ,OnCurrent)
	ON_UPDATE_COMMAND_UI(ID_FIRST		  ,OnMenuFirst)
	ON_UPDATE_COMMAND_UI(ID_LAST		  ,OnMenuLast)
	ON_UPDATE_COMMAND_UI(ID_UP			  ,OnMenuUp)
	ON_UPDATE_COMMAND_UI(ID_DOWN		  ,OnMenuDown)
	ON_UPDATE_COMMAND_UI(ID_CURRENT		  ,OnMenuCurrent)
	ON_UPDATE_COMMAND_UI(ID_VIEWMODE      ,OnMenuViewMode)
	ON_UPDATE_COMMAND_UI(ID_CPP_COPY      ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND_NEXT,OnMenuFind)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY     ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_FINDINNEXT	  ,OnMenuNext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CString	CFileCompareView::m_sClassName;


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CFileCompareView::CFileCompareView()
{
CRegKeys	sKey;


	if(m_sClassName=="")				// Neue Klasse erzeugen
		{
		m_sClassName=AfxRegisterWndClass(CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW,
		 								 LoadCursor(NULL,IDC_ARROW),
										 (HBRUSH)GetStockObject(NULL_BRUSH));
		}

	m_pBitMask	  = 0;					// Bit-Maske fr Vergleich
	m_bTilteOn	  = TRUE;				// Sind die Titel eingeschalten
	m_bTilteLook  = FALSE;				// Sind fixe Titel angegeben
	m_bViewMode	  = FALSE;				// Horizontal anzeigen
	m_bIntelAuto  = FALSE;				// Dateien automatisch im Intel-Hex-Format laden
	m_bIntelAutoX = FALSE;				// Dateien automatisch im Intel-Hex-Format laden (Commandline)
	m_bJumpOn	  = FALSE;				// Zum ersten Unterschied springen
	m_bIntel1	  = FALSE;				// Erste  Datei immer  im Intel-Hex-Format laden
	m_bIntel2	  = FALSE;				// Zeite  Datei immer  im Intel-Hex-Format laden

	m_uMemSize1	  = 0;					// Speichergren fr die Dateien
	m_uMemSize2	  = 0;					//		*
	m_bMapMode1	  = FALSE;				// Wurde die Datei als MapFile geffnet
	m_bMapMode2	  = FALSE;				//		*
	m_pMem1		  = NULL;				// Zeiger auf Speicherbereiche
	m_pMem2		  = NULL;				//		*	


	m_iDiffSize	  = 0;					// Gre des Unterschied Bereiches
	m_iDiffFirst  = 0;					// Position des ersten Unterschiedes
	m_iDiffFirstE = 0;					// Position des ersten Unterschiedendes
	m_iDiffLast	  = 0;					// Position des letzten Unterschiedes
	m_iDiffLastE  = 0;					// Position des letzten Unterschiedendes
	m_iDiffCount  = 0;					// Anzahl der Unterschiede
	
	m_bViewMode	  = FALSE;				// Horizontal anzeigen
	m_iMargin	  = 0;					// Position des Randes
	m_iMarginMul  = 1;					// Positionsdaten im Rand
	m_iMarginDiv  = 1;					// Positionsdaten im Rand

	GetCharWidths(m_bCharWidths,-1);	// Breiten der Buchstaben

	sKey.Open();
	sKey.Get(m_bViewMode ,"ViewMode"    );
	sKey.Get(m_bIntelAuto,"IntelHexAuto");

	m_cHexWnd.SetFlags((m_bViewMode)? HDW_HORZ:HDW_VERT);

   	sKey.Up("Find");

   	m_iFindFlags		= 0;				// Suchdaten
	m_pFindText	 	= 0;
	m_pFindResult	= 0;
	m_pFindGroups	= 0;

	
	sKey.Get(m_iFindFlags,"Flags");
   	sKey.Get((void**)&m_pFindText	,"FindText"		,REG_MULTI_SZ);
   	sKey.Get((void**)&m_pFindGroups	,"FindGroups"	,REG_MULTI_SZ);
	

	memset(m_aDiffArray,0,sizeof(m_aDiffArray));	

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CFileCompareView::~CFileCompareView()
{
CRegKeys	sKey;
int			i,iLen;


	if(m_pMem1)
		{
		if(m_bMapMode1)
			{
			m_sMap1.Close();
			}
		else{
			delete m_pMem1;
			}
		
		m_uMemSize1 = 0;
		m_bMapMode1 = FALSE;
		m_pMem1	    = NULL;
		}


	if(m_pMem2)
		{
		if(m_bMapMode2)
			{
			m_sMap2.Close();
			}
		else{
			delete m_pMem2;
			}
		
		m_uMemSize2 = 0;
		m_bMapMode2 = FALSE;
		m_pMem2	    = NULL;
		}


	sKey.Open();

	sKey.Set(m_bIntelAuto,"IntelHexAuto");
  	sKey.Set(m_bViewMode,"ViewMode");

   	sKey.Up("Find");
	sKey.Set(m_iFindFlags,"Flags");
   	
	if(m_pFindText)
		{
	   	for(i=0;m_pFindText[i];i+=iLen)iLen=strlen(m_pFindText+i)+1;
		iLen=i+1;
		sKey.Set((void*)m_pFindText,iLen,"FindText",REG_MULTI_SZ);
		delete m_pFindText;
		}

	if(m_pFindGroups)
		{
	   	for(i=0;m_pFindGroups[i];i+=iLen)iLen=strlen(m_pFindGroups+i)+1;
		iLen=i+1;
		sKey.Set((void*)m_pFindGroups,iLen,"FindGroups",REG_MULTI_SZ);
		delete m_pFindGroups;
		}
	
	if(m_pFindResult)delete m_pFindResult;
	if(m_pBitMask   )delete m_pBitMask;
	
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CFileCompareView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}


//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
void CFileCompareView::OnDraw(CDC *pDC)
{
int		i,iVal,iBit,iStart;
int		iLast,iPos,iCnt,iFind;


 

	if(m_iViewCY<=0)return;

	pDC->SelectStockObject(NULL_PEN);
	pDC->SelectObject(GetSysColorBrush(COLOR_3DLIGHT ));
	pDC->Rectangle(m_iMargin-1,0   ,m_iMargin+1 ,10000);
	pDC->SelectStockObject            (WHITE_BRUSH    );
	pDC->Rectangle(m_iMargin+0,0   ,m_iMargin+2 ,10000);
	pDC->SelectObject(GetSysColorBrush(COLOR_3DFACE  ));
	pDC->Rectangle(m_iMargin+1,0   ,m_iMargin+3 ,10000);
 	pDC->SelectObject(GetSysColorBrush(COLOR_3DSHADOW));
	pDC->Rectangle(m_iMargin+2,0   ,m_iMargin+4 ,10000);


	iBit   = 0;
	iLast  = 0;
	iStart =-1;


	for(i=0;i<m_iViewCY;i++,iLast=iPos)
		{
		iPos = ((i+1)*sizeof(m_aDiffArray)*8)/m_iViewCY;
		iCnt = iPos-iLast;

		if(iCnt<=0)continue;

		iFind = bit_find_1(m_aDiffArray,iPos,iLast);
		iVal  = (iFind<iPos)? 1:0;

		if(iVal==iBit)continue;

		if(iBit)pDC->SelectObject(GetSysColorBrush(COLOR_HIGHLIGHT));
		else	pDC->SelectObject(GetSysColorBrush(COLOR_SCROLLBAR));

		pDC->Rectangle(m_iMargin+3,iStart,m_iViewCX+2,i+1);

		
		iStart = i;
		iBit   = iVal;
		}

	if(iStart<i)
		{
		if(iBit)pDC->SelectObject(GetSysColorBrush(COLOR_HIGHLIGHT));
		else	pDC->SelectObject(GetSysColorBrush(COLOR_SCROLLBAR));

		pDC->Rectangle(m_iMargin+3,iStart,m_iViewCX+2,i+1);
		}

}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************

#ifdef _DEBUG
void CFileCompareView::AssertValid() const
{
	CView::AssertValid();
}

void CFileCompareView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFileCompareDoc* CFileCompareView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFileCompareDoc)));
	return (CFileCompareDoc*)m_pDocument;
}
#endif


//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CFileCompareView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{

	if(!CView::Create(m_sClassName,lpszWindowName,dwStyle,rect,pParentWnd,nID,pContext))
		{
		return FALSE;
		}
		
	if (!m_cHexWnd.Create(WS_VISIBLE,rect,this,ID_HEXWND))
		{
		return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CFileCompareView::OnSize(UINT nType,int iSizeX,int iSizeY) 
{
int		iRight;

	iRight		= MARGIN_SIZE+4+((iSizeX-1)&1);
	m_iMargin	= iSizeX-iRight;


	if(iSizeX && iSizeY)
		{
		m_iViewCX = iSizeX;	
		m_iViewCY = iSizeY;

		if(IsWindow(m_cHexWnd.m_hWnd))
			{
			m_cHexWnd.MoveWindow(0,0,m_iMargin,iSizeY);
			}	
		}
	
	
	
	
CView::OnSize(nType,iSizeX,iSizeY);
}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CFileCompareView::OnSetFocus(CWnd* pOldWnd) 
{
	m_cHexWnd.SetFocus();
}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CFileCompareView::OnUpdate(CView* pSender, LPARAM Slot, CObject* pHint) 
{



}


//*****************************************************************************
//*
//*		OnCppCopy
//*
//*****************************************************************************
void CFileCompareView::OnCppCopy()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_CPP_COPY);
}


//*****************************************************************************
//*
//*		OnChecksum
//*
//*****************************************************************************
void CFileCompareView::OnChecksum()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_CHECKSUM);
}


//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CFileCompareView::OnCopy()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_EDIT_COPY);
}


//*****************************************************************************
//*
//*		OnFindView
//*
//*****************************************************************************
void CFileCompareView::OnFindView()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_EDIT_FIND);
}


//*****************************************************************************
//*
//*		OnMoveTo
//*
//*****************************************************************************
void CFileCompareView::OnMoveTo()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_MOVETO);
}


//*****************************************************************************
//*
//*		OnHexConvert
//*
//*****************************************************************************
void CFileCompareView::OnHexConvert()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_HEX_CONVERT);
}


//*****************************************************************************
//*
//*		OnConfigView
//*
//*****************************************************************************
void CFileCompareView::OnConfigView()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_HEX_CONFIG);
}


//*****************************************************************************
//*
//*		OnFindNext
//*
//*****************************************************************************
void CFileCompareView::OnFindNext()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_EDIT_FIND_NEXT);
}


//*****************************************************************************
//*
//*		OnFindMark
//*
//*****************************************************************************
void CFileCompareView::OnFindMark()
{
	m_cHexWnd.SendMessage(WM_COMMAND,ID_EDIT_FIND_NEXT2);
}


//*****************************************************************************
//*
//*		OnMenuSelection
//*
//*****************************************************************************
void CFileCompareView::OnMenuSelection(CCmdUI *pCmdUI)
{
	m_cHexWnd.OnMenuSelection(pCmdUI);
}


//*****************************************************************************
//*
//*		OnMenuFind
//*
//*****************************************************************************
void CFileCompareView::OnMenuFind(CCmdUI *pCmdUI)
{
	m_cHexWnd.OnMenuFind(pCmdUI);
}


//*****************************************************************************
//*
//*		OnMenuNext
//*
//*****************************************************************************
void CFileCompareView::OnMenuNext(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_pFindResult && *m_pFindResult);
}


//*****************************************************************************
//*
//*		OnViewMode
//*
//*****************************************************************************
void CFileCompareView::OnMenuViewMode(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_bViewMode);}
void CFileCompareView::OnViewMode()
{

	m_bViewMode=!m_bViewMode;
	m_cHexWnd.SetFlags((m_bViewMode)? HDW_HORZ:HDW_VERT,HDW_HORZ|HDW_VERT);

}


//*****************************************************************************
//*
//*		SetViewMode
//*
//*****************************************************************************
//	Einstellen der Teilung
//	bMode	: 1=Horizontal 0=Vertikal
void CFileCompareView::SetViewMode(BOOL bMode)
{

	if(!m_bViewMode &&  bMode)OnViewMode();
	if( m_bViewMode && !bMode)OnViewMode();

}

//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Fenstertitel einstellen
//	iNr		: Fensternummer
//	pTitle	: Titel der eingeblendet werden soll
void CFileCompareView::SetTitle(int iNr,const char *pTitle)
{

	if(iNr)m_sTitel2=pTitle;
	else   m_sTitel1=pTitle;

	m_bTilteLook=TRUE;

	if(IsWindow(m_hWnd))UpdateTitles();
}


//*****************************************************************************
//*
//*		SetTitleMode
//*
//*****************************************************************************
//	Fenstertitel ein oder ausschalten
//	bOn	: TRUE = einschalten
void CFileCompareView::SetTitleMode(BOOL bOn)
{
	m_bTilteOn=bOn;
}


//*****************************************************************************
//*
//*		SetJumpMode
//*
//*****************************************************************************
//	Nach dem ffnen zum ersten Unterschied springen
//	bOn	: TRUE = einschalten
void CFileCompareView::SetJumpMode(BOOL bOn)
{
	m_bJumpOn=bOn;
}



//*****************************************************************************
//*
//*		UpdateTitles
//*
//*****************************************************************************
void CFileCompareView::UpdateTitles()
{

	if(m_bTilteOn)										// Sind die Titel eingeschalten
		{
		char cBuffer[256];
		int	 iSize;

		iSize=(m_bViewMode)? m_iViewCX-12:m_iViewCX/2-12;

		CommpressFileName(m_sTitel1,cBuffer,sizeof(cBuffer),iSize,m_bCharWidths);
		m_cHexWnd.SetTitle(0,cBuffer);

		CommpressFileName(m_sTitel2,cBuffer,sizeof(cBuffer),iSize,m_bCharWidths);
		m_cHexWnd.SetTitle(1,cBuffer);
		}
	else{
		m_cHexWnd.SetTitle(0,NULL);
		m_cHexWnd.SetTitle(1,NULL);
		}

}


//*****************************************************************************
//*
//*		OpenFiles
//*
//*****************************************************************************
//	ffnet zwei Dateien und macht eine Differenzanzeige
//	pFile1	: Name der ersten Datei
//	pFile2	: Name der zweiten Datei
//	Ergibt	0 Wenn alles geladen wurde
//			1 Wenn File1 nicht geffnet werden konnte
//			2 Wenn File2 nicht geffnet werden konnte
int CFileCompareView::OpenFiles(const char *pFile1,const char *pFile2)
{
BYTE	   *pDel;	
char	   *pMem;
char		cText[512];
int			iSize;
int			iMode;
int			iMax;
int			iMin;
int			iPos;
int			iHex;




	SetCursor(IDC_WAIT);

	m_sFileName1 = pFile1;
	m_sFileName2 = pFile2;
	
	memset(m_aDiffArray,0,sizeof(m_aDiffArray));
	

	if(m_pMem1)
		{
		if(m_bMapMode1)
			{
			m_sMap1.Close();
			}
		else{
			delete m_pMem1;
			}
		
		m_uMemSize1 = 0;
		m_bMapMode1 = FALSE;
		m_pMem1	    = NULL;
		}


	if(m_pMem2)
		{
		if(m_bMapMode2)
			{
			m_sMap2.Close();
			}
		else{
			delete m_pMem2;
			}
		
		m_uMemSize2 = 0;
		m_bMapMode2 = FALSE;
		m_pMem2	    = NULL;
		}


//******************** ffne die erste Datei **********************************

	iHex = 0;
	pDel = 0;

	if(CmpFileType(pFile1,"HEX;H86;IHX"))
		{
		sprintf(cText,"Soll die Datei %s im Intel-Hex-Format geladen werden ?",pFile1);
		
		if(m_bIntelAuto || m_bIntelAutoX || MessageBox(cText,"Frage",MB_YESNO|MB_ICONQUESTION)==IDYES)
			{
			iHex=1;
			}
		}


	if(m_bIntel1)
		{
		m_bIntel1 = FALSE;
		iHex      = 1;
		}

	
	if(iHex)											// Intel-Hex-Format			
		{
		m_pMem1     = HexLoad(pFile1,iSize);
		m_uMemSize1	= iSize;
		if(!m_pMem1)return 1;
		}
	else{
			pMem=m_sMap1.Open(pFile1);						
		if(!pMem)
			{
			if(ExistFile(pFile1)!=1 || LengthFile(pFile1)!=0)
				{
				SetCursor(IDC_ARROW);
				return 1;
				}

			m_pMem1     = new BYTE[1];
			m_bMapMode1 = FALSE;
			m_uMemSize1 = 0;
			}
		else{
			m_uMemSize1 = m_sMap1.GetLength();

			if(m_uMemSize1<0x400000)
				{
				m_pMem1  = new BYTE[m_uMemSize1];
				memcpy(m_pMem1,pMem,m_uMemSize1);
				m_sMap1.Close();
				}
			else{
				m_bMapMode1 = TRUE;
				m_pMem1	    = (BYTE*)pMem;
				}
			}
		}


//******************** ffne die zweite Datei *********************************	


	iHex = 0;

	if(CmpFileType(pFile2,"HEX;H86;IHX"))
		{
		sprintf(cText,"Soll die Datei %s im Intel-Hex-Format geladen werden ?",pFile2);
		if(m_bIntelAuto || m_bIntelAutoX || MessageBox(cText,"Frage",MB_YESNO|MB_ICONQUESTION)==IDYES)
			{
			iHex=1;
			}
		}

	
	if(m_bIntel1)
		{
		m_bIntel1 = FALSE;
		iHex      = 1;
		}


	if(iHex)											// Intel-Hex-Format
		{
		m_pMem2     = HexLoad(pFile2,iSize);
		m_uMemSize2	= iSize;
		if(!m_pMem2)return 1;
		}
	else{
			pMem=m_sMap2.Open(pFile2);						
		if(!pMem)
			{
			if(ExistFile(pFile2)!=1 || LengthFile(pFile2)!=0)
				{
				SetCursor(IDC_ARROW);
				return 2;
				}

			m_pMem2     = new BYTE[2];
			m_bMapMode2 = FALSE;
			m_uMemSize2 = 0;
			}
		else{
			m_uMemSize2 = m_sMap2.GetLength();

			if(m_uMemSize2<0x400000)
				{
				m_pMem2  = new BYTE[m_uMemSize2];
				memcpy(m_pMem2,pMem,m_uMemSize2);
				m_sMap2.Close();
				}
			else{
				m_bMapMode2 = TRUE;
				m_pMem2	    = (BYTE*)pMem;
				}
			}
		}


	if(m_pBitMask)
		{
		pDel = m_pBitMask;
		}

	if(m_uMemSize1>m_uMemSize2)
		{
		iMax = m_uMemSize1;
		iMin = m_uMemSize2;
		}
	else{
		iMax = m_uMemSize2;
		iMin = m_uMemSize1;
		}

	
	
	m_pBitMask = new BYTE[(iMax+0x47)/8];
	m_pBitMask[iMin/8] = 0;

	m_iDiffSize	  = iMax;								// Gre des Unterschied Bereiches
	m_iDiffFirst  = 0;									// Position des ersten Unterschiedes
	m_iDiffFirstE = 0;									// Position des ersten Unterschiedendes
	m_iDiffLast	  = 0;									// Position des letzten Unterschiedes
	m_iDiffLastE  = 0;									// Position des letzten Unterschiedendes
	m_iDiffCount  = 0;									// Anzahl der Unterschiede

	memset(m_pBitMask,0,(iMax+7)/8);
	iMode = 0;

	m_iMarginDiv  = (iMax+(sizeof(m_aDiffArray)/4)-1)/(sizeof(m_aDiffArray)/4);


	if(iMax>=0x04000000)
		{
		m_iMarginMul  = 1;
		m_iMarginDiv /= 32;
		}
	else{
		m_iMarginMul  = 32;
		}

	if(m_iMarginDiv<=0)m_iMarginDiv=1;		

	
	
	for(iPos=0;iPos<iMin;iPos++)						// Suche den ersten Unterschied
		{
		if(m_pMem1[iPos]==m_pMem2[iPos])
			{
			iMode = 0;
			continue;
			}
		
		bit_set(m_pBitMask,iPos);
		bit_set(m_aDiffArray,iPos*m_iMarginMul/m_iMarginDiv);

		m_iDiffFirst = iPos;
		m_iDiffLast  = iPos;
		m_iDiffCount = 1;
		iMode		 = 1;
		
		break;
		}

	
	for(;iPos<iMin;iPos++)								// Suche weitere Unterschiede
		{
		if(m_pMem1[iPos]==m_pMem2[iPos])
			{
			iMode = 0;
			continue;
			}
		
		bit_set(m_pBitMask,iPos);
		bit_set(m_aDiffArray,iPos*m_iMarginMul/m_iMarginDiv);

		if(!iMode)										// Neuer Bereich
			{
			iMode       = 1;
			m_iDiffLast = iPos;
			m_iDiffCount++; 
			}
		}

	if(!iMode && iMin<iMax)								// Bei unterschiedlicher Lnge Unterschied anhngen
		{
		iMode       = 1;
		m_iDiffLast = iPos;
		m_iDiffCount++; 
		}


	for(;iPos<iMin;iPos++)
		{
		if(m_pMem1[iPos]==m_pMem2[iPos])continue;
		bit_set(m_pBitMask,iPos);
		bit_set(m_aDiffArray,iPos*m_iMarginMul/m_iMarginDiv);
		}

	for(;iPos<iMax;iPos++)
		{
		bit_set(m_pBitMask,iPos);
		bit_set(m_aDiffArray,iPos*m_iMarginMul/m_iMarginDiv);
		}

	
	if(m_iDiffCount>0)
		{
		m_iDiffFirstE = bit_find_0(m_pBitMask,m_iDiffSize,m_iDiffFirst);
		m_iDiffLastE  = bit_find_0(m_pBitMask,m_iDiffSize,m_iDiffLast );
		}


//******************** Abschlussarbeiten am Fenster ***************************

	m_bIntelAutoX = FALSE;

	m_cHexWnd.SetMem(0,m_pMem1,m_uMemSize1);
	m_cHexWnd.SetMem(1,m_pMem2,m_uMemSize2);
	m_cHexWnd.SetBitSelection(0,m_pBitMask);
	m_cHexWnd.SetBitSelection(1,m_pBitMask);

	if(pDel)delete pDel;								// Alte Bitmake lschen


	if(!m_bTilteLook)									// Pfade als Titel fr Texte
		{
		m_sTitel1=pFile1;
		m_sTitel2=pFile2;
		}

	m_cHexWnd.SetFilePath(0,pFile1);					// Pfade an Fenster bergeben
	m_cHexWnd.SetFilePath(1,pFile2);

	UpdateTitles();


	RedrawWindow();
	SetCursor(IDC_ARROW);


	if(m_bJumpOn)										// Zum ersten Unterschied springen			
		{
		m_bJumpOn = FALSE;
		PostMessage(WM_COMMAND,ID_FIRST);
		}



return 0;
}



//*****************************************************************************
//*
//*		OnOpenFiles
//*
//*****************************************************************************
//	ffnet zwei Dateien
void CFileCompareView::OnOpenFiles()
{
CString		sText;
COpenDlg	sDlg;
int			iErr;
int			iRet;



	sDlg.m_sPath1		= m_sFileName1;
	sDlg.m_sPath2		= m_sFileName2;
	sDlg.m_bIntelAuto	= m_bIntelAuto;
	sDlg.m_bIntel1		= m_bIntel1;
	sDlg.m_bIntel2		= m_bIntel2;

	iRet = sDlg.DoModal();
	AfxGetMainWnd()->ShowWindow(SW_SHOW);

	if(iRet!=IDOK)
		{
		return;
		}

	if(sDlg.m_sPath1 == m_sFileName1)
	if(sDlg.m_sPath2 == m_sFileName2)

	if(sDlg.m_sPath1 != m_sFileName1)m_bTilteLook=FALSE;
	if(sDlg.m_sPath2 != m_sFileName2)m_bTilteLook=FALSE;

	m_bIntelAutoX	  = FALSE;
	m_bIntelAuto	  = sDlg.m_bIntelAuto;
	m_bIntel1		  = sDlg.m_bIntel1;
	m_bIntel2		  = sDlg.m_bIntel2;


	iErr = OpenFiles(sDlg.m_sPath1,sDlg.m_sPath2);


	switch(iErr)
		{
	case 0:	break;

	case 1:	sText.Format("Die erste Datei %s konnte nicht geffnet werden !",(LPCSTR)sDlg.m_sPath1);
			MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			break;

	case 2:	sText.Format("Die zweite Datei %s konnte nicht geffnet werden !",(LPCSTR)sDlg.m_sPath2);
			MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			break;

	default:MessageBox("Unbekannter Fehler !","Fehler",MB_OK|MB_ICONERROR);
			break;
		}



}


//*****************************************************************************
//*
//*		OnFirst
//*
//*****************************************************************************
//	Zum ersten genderten Bereich
void CFileCompareView::OnFirst()
{
int		iOff;

	

	if(m_iDiffCount<=0)return;

	iOff = m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd());

	if(iOff>=m_iDiffFirst && iOff<m_iDiffFirstE)return;

	m_cHexWnd.SetCursor(m_iDiffFirst);

}


//*****************************************************************************
//*
//*		OnLast
//*
//*****************************************************************************
//	Zum letzten genderten Bereich
void CFileCompareView::OnLast()
{
int		iOff;



	if(m_iDiffCount<=0)return;

	iOff = m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd());
	
	if(iOff>=m_iDiffLast && iOff<m_iDiffLastE)return;

	m_cHexWnd.SetCursor(m_iDiffLast);

}

//*****************************************************************************
//*
//*		OnUp
//*
//*****************************************************************************
//	Zum nchsten genderten Bereich
void CFileCompareView::OnUp()
{
int		iOff;



	if(m_iDiffCount<=0)return;

	iOff = m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd());
	
	if(iOff>=m_iDiffLast)return;

	if(bit_read(m_pBitMask,iOff))
		{
		iOff = bit_find_0(m_pBitMask,m_iDiffSize,iOff);
		}
	
	iOff = bit_find_1(m_pBitMask,m_iDiffSize,iOff);
	m_cHexWnd.SetCursor(iOff);

}


//*****************************************************************************
//*
//*		OnDown
//*
//*****************************************************************************
//	Zum vorherigen Bereich sprigen
void CFileCompareView::OnDown()
{
int		iOff;



	if(m_iDiffCount<=0)return;

	iOff = m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd());
	
	if(iOff<m_iDiffFirst)return;

	while(iOff>0 && bit_read(m_pBitMask,iOff))
		{
		iOff--;
		}

	while(iOff>0 && !bit_read(m_pBitMask,iOff))
		{
		iOff--;
		}
	
	while(iOff>0 && bit_read(m_pBitMask,iOff))
		{
		iOff--;
		}


	iOff = bit_find_1(m_pBitMask,m_iDiffSize,iOff);
	m_cHexWnd.SetCursor(iOff);

}


//*****************************************************************************
//*
//*		OnCurrent
//*
//*****************************************************************************
//	Zum aktuellen Bereich scrollen
void CFileCompareView::OnCurrent()
{
int		iOff,iEnd,iPos;


	if(m_iDiffCount<=0)return;

	iOff = m_cHexWnd.GetCursor  (0);
	iPos = m_cHexWnd.GetScroll  (0);
	iEnd = m_cHexWnd.GetViewSize(0)+iPos;

	if(iOff<iPos || iOff>=iEnd)
		{
		m_cHexWnd.SetScroll(iOff,0);
		}

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CFileCompareView::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
int		iScr,iOff,iPos;


	if(m_iViewCY<=0)return;

	iPos  = (sPoint.y*sizeof(m_aDiffArray)*8)/m_iViewCY;
	iOff  = (iPos*m_iMarginDiv)/m_iMarginMul;


	   iScr =  iOff-m_cHexWnd.GetViewSize(0)/2;
	if(iScr<0)iScr=0;

	m_cHexWnd.SetScroll(iScr);
	m_cHexWnd.SetCursor(iOff);
	


}

//*****************************************************************************
//*
//*		OnMenu
//*
//*****************************************************************************
void CFileCompareView::OnMenuFirst    (CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iDiffCount>0 && (m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd())>=m_iDiffFirstE || m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd())>=m_iDiffFirstE));
}
void CFileCompareView::OnMenuLast     (CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iDiffCount>0 && (m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd())<m_iDiffLast  || m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd())>=m_iDiffLastE ));
}
void CFileCompareView::OnMenuUp       (CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iDiffCount>0 &&  m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd())<m_iDiffLast);
}
void CFileCompareView::OnMenuDown     (CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iDiffCount>0 &&  m_cHexWnd.GetCursor(m_cHexWnd.GetActiveWnd())>m_iDiffFirstE);
}
void CFileCompareView::OnMenuCurrent  (CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iDiffCount>0);
}


//*****************************************************************************
//*
//*		HexLoad
//*
//*****************************************************************************
//	Eine Datei im Intel-Hex-Format laden
//	pFilename	: Ist der Name der Datei die geladen werden soll
//	iSize		: Hier wird die Datenlnge gespeichert
//	pOld		: Ist der Zeiger auf den zuvor allokierten Zeiger
//	Ergibt einen Zeiger auf die Daten (mit delete freigeben)
unsigned char *CFileCompareView::HexLoad(const char *pFilename,int &iSize,unsigned char *pOld)
{
#define 		NORMAL	0xFF
FILE		   *pFile;
char		   *pPtr , cLine[256];
unsigned char  *pMem ,*pMemNew;
unsigned char	ucHex  [128];
int				iNormal,iMax,iEnd,iOff=0;
int				i,iLen,iPos,iCount;
		 




		pFile=fopen(pFilename,"rb");
	if(!pFile)return 0;



	iNormal = NORMAL;

	if(pOld)												// Alten Speicher verwenden
		{
		pMem	= pOld;
		iEnd	= iSize;
		iMax	= iSize;
		}
	else{													// Speicher erzeugen
		iSize	= 0;
		iMax	= 0;
		iEnd	= 0x10000;
		pMem	= new unsigned char[iEnd];
		memset(pMem,iNormal,iEnd);
		}

	while(fgets(cLine,sizeof(cLine),pFile))					// Zeile einlesen
		{
		pPtr  = cLine;
		pPtr += strspn(pPtr,"\n ");

		if(*pPtr!=':')continue;

		   iLen=dumptomem(ucHex,sizeof(ucHex),pPtr);
		if(iLen<5    )continue;								// Dump ist Leer

		if(ucHex[3]==2 && ucHex[0]>=2 && iLen>=7)			// Daten Offset ?
			{
			iOff = ucHex[4]*4096+ucHex[5]*16;
			continue;
			}

		if(ucHex[3]==4 && ucHex[0]>=2 && iLen>=7)			// Daten Offset ?
			{
			iOff = ucHex[4]*0x1000000+ucHex[5]*0x10000;
			continue;
			}

		if(ucHex[3]!=0)continue;							// Daten Bytes ?

		iPos	=(ucHex[1]<<8)+ucHex[2];
		iCount	= ucHex[0];
		if(iCount+5>iLen)iCount=iLen-5;

		if(pOld && iPos+iOff+iCount>iEnd)					// berlauf prfen
			{
			   iCount=iEnd-iOff-iPos;
			if(iCount<=0)continue;
			}

		if(iPos+iOff+iCount>iEnd)							// Speicher vergrern
			{
			i=(iPos+iOff|0xFFFF)+1;
			pMemNew=new unsigned char[i];
			memset(pMemNew+iEnd,iNormal,i-iEnd);
			memcpy(pMemNew,pMem,iEnd);
			delete pMem;
			pMem=pMemNew;
			iEnd=i;
			}


		memcpy(pMem+iPos+iOff,ucHex+4,iCount);				//  Bytes kopieren


		if(iMax<iPos+iCount+iOff)iMax=iPos+iCount+iOff;		//  Lnge berechnen
		}



	iMax--;
	iMax|=0x3FF;
	iMax++;


	iSize=iMax;


return pMem;
}


//*****************************************************************************
//*
//*		SetLoadMode
//*
//*****************************************************************************
//	Einstellen der Lade Optionen
void CFileCompareView::SetLoadMode(BOOL bIntel1,BOOL bIntel2,int iIntelAuto)
{
	m_bIntelAutoX = iIntelAuto;								// Dateien automatisch im Intel-Hex-Format laden
	m_bIntel1	  = bIntel1;								// Erste  Datei immer  im Intel-Hex-Format laden
	m_bIntel2	  = bIntel2;								// Zeite  Datei immer  im Intel-Hex-Format laden

}


//*****************************************************************************
//*
//*		OnReload
//*
//*****************************************************************************
void CFileCompareView::OnReload()
{
CString		sText;
int			iErr;


	if(m_sFileName1=="")return;
	if(m_sFileName2=="")return;

	iErr=OpenFiles(m_sFileName1,m_sFileName2);


	switch(iErr)
		{
	case 0:	break;

	case 1:	sText.Format("Die erste Datei %s konnte nicht geffnet werden !",(LPCSTR)m_sFileName1);
			MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			break;

	case 2:	sText.Format("Die zweite Datei %s konnte nicht geffnet werden !",(LPCSTR)m_sFileName2);
			MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			break;

	default:MessageBox("Unbekannter Fehler !","Fehler",MB_OK|MB_ICONERROR);
			break;
		}


}

//*****************************************************************************
//*
//*		OnColorView
//*
//*****************************************************************************
void CFileCompareView::OnColorView()
{
	m_cHexWnd.ColorView();
}

//*****************************************************************************
//*
//*		OnFontView
//*
//*****************************************************************************
void CFileCompareView::OnFontView()
{
	m_cHexWnd.FontView();
}
