//*****************************************************************************
//*
//*
//*		FileCompareView.h : Schnittstelle der Klasse CFileCompareView
//*
//*
//*****************************************************************************
#if !defined(AFX_FILECOMPAREVIEW_H__91FBEE6B_A94C_4C08_A64A_817F94E747FC__INCLUDED_)
#define      AFX_FILECOMPAREVIEW_H__91FBEE6B_A94C_4C08_A64A_817F94E747FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include	"HexDoubleWnd.h"



//*****************************************************************************
//*
//*		CFileCompareView
//*
//*****************************************************************************
class CFileCompareView : public CView
{
protected:

	CFileCompareView();
	DECLARE_DYNCREATE(CFileCompareView)

public:

	CFileCompareDoc  *GetDocument();
	void			 SetTitle(int iNr,const char *pTitle);
	void			 SetTitleMode(BOOL bOn);
	void			 SetJumpMode(BOOL bOn=TRUE);
	void			 SetViewMode(BOOL bMode);
	void			 SetLoadMode(BOOL bIntel1,BOOL bIntel2,int iIntelAuto);
	int				 SetCompareMode(int iMode);
	int				 OpenFiles(const char *pFile1,const char *pFile2);

	//{{AFX_VIRTUAL(CFileCompareView)
	public:
	virtual void OnDraw(CDC *pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementierung
public:

	virtual ~CFileCompareView();
	#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif


protected:

	//{{AFX_MSG(CFileCompareView)
	afx_msg	void OnLButtonDown(UINT nFlags,CPoint sPoint);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg	void OnCppCopy();
	afx_msg	void OnChecksum();
	afx_msg	void OnCopy();
	afx_msg	void OnConfigView();
	afx_msg	void OnFindView();
	afx_msg	void OnFindNext();
	afx_msg	void OnFindMark();
	afx_msg	void OnMoveTo();
	afx_msg	void OnHexConvert();
	afx_msg	void OnViewMode();
	afx_msg	void OnOpenFiles();
	afx_msg	void OnReload();
	afx_msg	void OnFirst();
	afx_msg	void OnLast();
	afx_msg	void OnUp();
	afx_msg	void OnDown();
	afx_msg	void OnCurrent();
	afx_msg	void OnFontView();
	afx_msg	void OnColorView();
	afx_msg	void OnMenuSelection(CCmdUI *pCmdUI);
	afx_msg void OnMenuViewMode (CCmdUI *pCmdUI);
	afx_msg	void OnMenuNext     (CCmdUI *pCmdUI);
	afx_msg	void OnMenuFind     (CCmdUI *pCmdUI);
	afx_msg	void OnMenuFirst    (CCmdUI *pCmdUI);
	afx_msg	void OnMenuLast     (CCmdUI *pCmdUI);
	afx_msg	void OnMenuUp       (CCmdUI *pCmdUI);
	afx_msg	void OnMenuDown     (CCmdUI *pCmdUI);
	afx_msg	void OnMenuCurrent  (CCmdUI *pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void			UpdateTitles();
	unsigned char  *HexLoad(const char *pFilename,int &iSize,unsigned char *pOld=NULL);


	static CString	m_sClassName;
	CHexDoubleWnd	m_cHexWnd;
	CString			m_sTitel1;					// Titel fr Texte
	CString			m_sTitel2;					//		*
	CString			m_sFileName1;				// Namen der Dateien
	CString			m_sFileName2;				//		*
	BOOL			m_bJumpOn;					// Zum ersten Unterschied springen
	BOOL			m_bTilteOn;					// Sind die Titel eingeschalten		
	BOOL			m_bTilteLook;				// Sind fixe Titel angegeben
	BOOL			m_bViewMode;				// Horizontal anzeigen
	BOOL			m_bIntelAutoX;				// Dateien automatisch im Intel-Hex-Format laden (Commandline)
	BOOL			m_bIntelAuto;				// Dateien automatisch im Intel-Hex-Format laden
	BOOL			m_bIntel1;					// Erste  Datei immer  im Intel-Hex-Format laden
	BOOL			m_bIntel2;					// Zeite  Datei immer  im Intel-Hex-Format laden

	CMapFile		m_sMap1;					// Map-Files fr Dateien
	CMapFile		m_sMap2;					//		*
	UINT			m_uMemSize1;				// Speichergren fr die Dateien
	UINT			m_uMemSize2;				//		*
	BOOL			m_bMapMode1;				// Wurde die Datei als MapFile geffnet
	BOOL			m_bMapMode2;				//		*
	BYTE		   *m_pMem1;					// Zeiger auf Speicherbereiche
	BYTE		   *m_pMem2;					//		*	
	BYTE		   *m_pBitMask;					// Bit-Maske fr Vergleich

	int				m_iDiffSize;				// Gre des Unterschied Bereiches
	int				m_iDiffFirst;				// Position des ersten Unterschiedes
	int				m_iDiffFirstE;				// Position des ersten Unterschiedendes
	int				m_iDiffLast;				// Position des letzten Unterschiedes
	int				m_iDiffLastE;				// Position des letzten Unterschiedendes
	int				m_iDiffCount;				// Anzahl der Unterschiede

	int				m_iViewCX;					// Gre des Fensters
	int				m_iViewCY;					//		*
	int				m_iMargin;					// Position des Randes
	int				m_iMarginMul;				// Positionsdaten im Rand
	int				m_iMarginDiv;				// Positionsdaten im Rand

   	int				m_iFindFlags;				// Suchendaten
	char		   *m_pFindText;
	char		   *m_pFindGroups;
	char		   *m_pFindResult;

	BYTE			m_bCharWidths[256];			// Breiten der Buchstaben
	BYTE			m_aDiffArray [256];			// Unterschiedbitfeld

};

#ifndef _DEBUG  // Testversion in FileCompareView.cpp
inline CFileCompareDoc* CFileCompareView::GetDocument()
   { return (CFileCompareDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
#endif
