//*****************************************************************************
//*
//*
//*		CHexDoubleWnd Klasse
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"Resource.h"
#include 	"HexWnd.h"
#include 	"HexDoubleWnd.h"

		  
#ifdef	   _DEBUG
#define new	DEBUG_NEW
#undef		THIS_FILE
static char	THIS_FILE[] = __FILE__;
#endif

#define 	HEX_ID1				0x1000
#define 	HEX_ID2				0x1001

#ifndef		ID_HEX_CONFIG
#define 	ID_HEX_CONFIG		0x8900
#endif 	
#ifndef		ID_CHECKSUM
#define 	ID_CHECKSUM			0x8901
#endif 	
#ifndef		ID_EDIT_FIND_NEXT
#define 	ID_EDIT_FIND_NEXT	0x8902
#endif 	
#ifndef		ID_EDIT_FIND_NEXT2
#define 	ID_EDIT_FIND_NEXT2	0x8903
#endif 	
#ifndef		ID_MOVETO
#define 	ID_MOVETO			0x8904
#endif 	
#ifndef		ID_INPUTVALUE
#define 	ID_INPUTVALUE		0x8905
#endif 	
#ifndef		ID_CPP_COPY
#define 	ID_CPP_COPY			0x8906
#endif 	
#ifndef		ID_HEX_CONVERT
#define 	ID_HEX_CONVERT		0x8907
#endif 	
#ifndef		ID_VIEW_COLOR
#define 	ID_VIEW_COLOR		0x8908
#endif 	
#ifndef		ID_VIEW_FONT
#define 	ID_VIEW_FONT		0x8909
#endif 	
#ifndef		ID_COPYPATH
#define 	ID_COPYPATH			0x8906
#endif 	
#ifndef		ID_START_EDITOR
#define 	ID_START_EDITOR		0x8907
#endif 	


BEGIN_MESSAGE_MAP(CHexDoubleWnd, CWnd)
	//{{AFX_MSG_MAP(CHexDoubleWnd)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_SETFOCUS()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_HEX_CONFIG  			  ,OnConfigView)
	ON_COMMAND(ID_EDIT_FIND   			  ,OnSuchenView)
	ON_COMMAND(ID_EDIT_FIND_NEXT		  ,OnSuchenWeiter)
	ON_COMMAND(ID_EDIT_FIND_NEXT2		  ,OnSuchenMarke)
	ON_COMMAND(ID_EDIT_COPY				  ,OnCopy)
	ON_COMMAND(ID_COPYPATH  			  ,OnCopyPath)
	ON_COMMAND(ID_START_EDITOR			  ,OnStartEditor)
	ON_COMMAND(ID_MOVETO				  ,OnMoveTo)
	ON_COMMAND(ID_CPP_COPY				  ,OnCppCopy)
	ON_COMMAND(ID_CHECKSUM				  ,OnChecksum)
	ON_COMMAND(ID_VIEW_FONT				  ,OnFontView)
	ON_COMMAND(ID_VIEW_COLOR			  ,OnColorView)
	ON_COMMAND(ID_HEX_CONVERT			  ,OnHexConvert)	
	ON_UPDATE_COMMAND_UI(ID_CPP_COPY      ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY     ,OnMenuSelection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND_NEXT,OnMenuFind)
	//}}AFX_MSG_MAP
	ON_NOTIFY(ANSI_SCROLL,HEX_ID1		  ,OnScrollChange)
	ON_NOTIFY(ANSI_SCROLL,HEX_ID2		  ,OnScrollChange)
	ON_NOTIFY(HEX_SELCHANGE,HEX_ID1		  ,OnMarkChange)
	ON_NOTIFY(HEX_SELCHANGE,HEX_ID2		  ,OnMarkChange)
	ON_NOTIFY(HEX_CONFIGCHANGE,HEX_ID1	  ,OnConfigChange)
	ON_NOTIFY(HEX_CONFIGCHANGE,HEX_ID2	  ,OnConfigChange)
	ON_NOTIFY(HEX_KILLFOCUS,HEX_ID1		  ,OnKillFocusChange)
	ON_NOTIFY(HEX_KILLFOCUS,HEX_ID2		  ,OnKillFocusChange)
	ON_NOTIFY(HEX_SETFOCUS,HEX_ID1		  ,OnSetFocusChange)
	ON_NOTIFY(HEX_SETFOCUS,HEX_ID2		  ,OnSetFocusChange)
END_MESSAGE_MAP()

CString	CHexDoubleWnd::class_name;	

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CHexDoubleWnd::CHexDoubleWnd(int Art)
{

	flags=Art;		

	if(class_name=="")								// Neue Klasse erzeugen
		{
		class_name=AfxRegisterWndClass(CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW,
		 								 LoadCursor(NULL,IDC_IBEAM),
										 (HBRUSH)GetStockObject(NULL_BRUSH));

		}


	titel[0]=0;										// Zeiger auf Titel-Texte
	titel[1]=0;

	focus_wnd	= 0;
	copy_index	= 0;								// Index fr's Kopiern

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CHexDoubleWnd::~CHexDoubleWnd()
{

	if(titel[0])delete titel[0];
	if(titel[1])delete titel[1];

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CHexDoubleWnd::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID)
{

	if(!CWnd::Create(class_name,"HexDoubleWnd",dwStyle,rect,pParentWnd,nID))
		{
		return FALSE;
		}

	if(!hex_wnd[0].Create(WS_VISIBLE,rect,this,HEX_ID1))return FALSE;
	if(!hex_wnd[1].Create(WS_VISIBLE,rect,this,HEX_ID2))return FALSE;

	hex_wnd[0].SetWidth(-1,-1,-1,8);
	hex_wnd[1].SetWidth(-1,-1,-1,8);

	if(!title_wnd[0].CreateEx(WS_EX_CLIENTEDGE,_T("STATIC"),(titel[0])? titel[0]:0,SS_LEFT|WS_CHILD,rect,this,0xFFFF))return FALSE;
	if(!title_wnd[1].CreateEx(WS_EX_CLIENTEDGE,_T("STATIC"),(titel[1])? titel[1]:0,SS_LEFT|WS_CHILD,rect,this,0xFFFF))return FALSE;


	title_wnd[0].SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));
	title_wnd[1].SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));

	SetStyleEx(title_wnd[0],WS_EX_CLIENTEDGE);
	SetStyleEx(title_wnd[1],WS_EX_CLIENTEDGE);


return TRUE;
}


//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
void CHexDoubleWnd::OnPaint()
{
CPaintDC	dc(this);
int			pos;




	if(flags&HDW_HORZ)
		{
		pos=(view_y>>1)-3;
		if(pos<0)pos=0;

		dc.SelectStockObject(NULL_PEN       );
		dc.SelectObject(GetSysColorBrush(COLOR_3DLIGHT));
		dc.Rectangle   (0,pos  ,10000,pos+2 );
		dc.SelectStockObject(WHITE_BRUSH    );
		dc.Rectangle   (0,pos+1,10000,pos+3 );
		dc.SelectObject(GetSysColorBrush(COLOR_3DFACE));
		dc.Rectangle   (0,pos+2,10000,pos+6 );
 		dc.SelectObject(GetSysColorBrush(COLOR_3DSHADOW));
		dc.Rectangle   (0,pos+5,10000,pos+7 );
		dc.SelectStockObject(BLACK_BRUSH    );
		dc.Rectangle   (0,pos+6,10000,pos+8 );
		}

}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CHexDoubleWnd::OnSize(UINT nType, int cx, int cy) 
{
int		x_brt,y_brt,y_brt1,x_pos;
int		max,titel_on;



	if(!cx || !cy)return;

	view_x=cx;
	view_y=cy;
	max   =GetSystemMetrics(SM_CYHSCROLL)+3;
	if(max<19)max=19;
	titel_on = (titel[0] || titel[1])? max:0;

	if(flags&HDW_HORZ)
		{
		x_brt = cx;
		y_brt = (cy>>1)-3;
		if(y_brt<0)y_brt=0;

		if(IsWindow(hex_wnd[0].m_hWnd))
			{
			hex_wnd[0].MoveWindow(0,titel_on,x_brt,y_brt-titel_on);
			}

		if(IsWindow(hex_wnd[1].m_hWnd))
			{
			y_brt1=view_y-y_brt-7;
			if(y_brt1<0)y_brt1=0;
			hex_wnd[1].MoveWindow(0,y_brt+7+titel_on,x_brt,y_brt1-titel_on);
			}

		if(IsWindow(title_wnd[0].m_hWnd))
			{
			title_wnd[0].ShowWindow((titel_on)? SW_SHOW:SW_HIDE);
			title_wnd[0].MoveWindow(0,0,x_brt,titel_on);
			}

		if(IsWindow(title_wnd[1].m_hWnd))
			{
			title_wnd[1].ShowWindow((titel_on)? SW_SHOW:SW_HIDE);
			title_wnd[1].MoveWindow(0,y_brt+7,x_brt,titel_on);
			}
		}
	else{
		x_brt = cx>>1;
		y_brt = cy;
		x_pos = x_brt+((cx+2)&1)-1;

		if(IsWindow(hex_wnd[0].m_hWnd))
			{
			hex_wnd[0].MoveWindow(0,titel_on,x_brt,y_brt-titel_on);									
			}

		if(IsWindow(hex_wnd[1].m_hWnd))
			{
			hex_wnd[1].MoveWindow(x_brt,titel_on,x_brt,y_brt-titel_on);
			}

		if(IsWindow(title_wnd[0].m_hWnd))
			{
			title_wnd[0].ShowWindow((titel_on)? SW_SHOW:SW_HIDE);
			title_wnd[0].MoveWindow(0,0,x_brt,titel_on);
			}

		if(IsWindow(title_wnd[1].m_hWnd))
			{
			title_wnd[1].ShowWindow((titel_on)? SW_SHOW:SW_HIDE);
			title_wnd[1].MoveWindow(x_pos,0,x_brt,titel_on);
			}
		}

	
}

//*****************************************************************************
//*
//*		OnScrollChange
//*
//*****************************************************************************
//	Scroll nderung
void CHexDoubleWnd::OnScrollChange(NMHDR *pNmHdr, LRESULT *pResult)
{
ANSI_NMHDR	*hrd=(ANSI_NMHDR*)pNmHdr;
OffU		 off;


	if(hrd->sHdr.idFrom==HEX_ID1)
		{
		off=(OffU)hex_wnd[0].GetScroll();
				  hex_wnd[1].SetScroll(off);
		}
	else{
		off=(OffU)hex_wnd[1].GetScroll();
				  hex_wnd[0].SetScroll(off);
		}


	*pResult=1;

}

//*****************************************************************************
//*
//*		OnSetFocusChange
//*
//*****************************************************************************
void CHexDoubleWnd::OnSetFocusChange(NMHDR *pNmHdr, LRESULT *pResult)
{
HEX_NMHDR  *hrd=(HEX_NMHDR*)pNmHdr;

	if(hrd->sHdr.idFrom==HEX_ID2)focus_wnd=1;
	else						  focus_wnd=0;
	
}
 
//*****************************************************************************
//*
//*		OnKillFocusChange
//*
//*****************************************************************************
void CHexDoubleWnd::OnKillFocusChange(NMHDR *pNmHdr, LRESULT *pResult)
{
HEX_NMHDR  *hrd=(HEX_NMHDR*)pNmHdr;

	if(hrd->sHdr.idFrom==HEX_ID2)focus_wnd=1;
	else						  focus_wnd=0;
	
}

//*****************************************************************************
//*
//*		OnConfigChange
//*
//*****************************************************************************
void CHexDoubleWnd::OnConfigChange(NMHDR *pNmHdr, LRESULT *pResult)
{
HEX_NMHDR  *hrd=(HEX_NMHDR*)pNmHdr;
int			invert,format,sellock;
int			breite,nspace,space,adr_len;
int			braster,raster,wert;
int			i=0;
	

	if(hrd->sHdr.idFrom==HEX_ID2)i=1;
	
	breite	=hex_wnd[i].GetConfig( 0);		// Bytebreite einer Zeile
	nspace	=hex_wnd[i].GetConfig( 1);		// Bytezahl fr extra Space
	space	=hex_wnd[i].GetConfig( 2);		// Space anhngen
	raster	=hex_wnd[i].GetConfig( 3);		// Adresse einrasten
	braster	=hex_wnd[i].GetConfig( 4);		// Raster Schritte fr Breite
	wert	=hex_wnd[i].GetConfig( 6);		// Statusbar Wert-Anzeige
	adr_len	=hex_wnd[i].GetConfig( 7);		// Anzahl der Adressziffern
	format	=hex_wnd[i].GetConfig( 8);		// Ausgabeformat 0=byte 1=word 2=dword 3=qword
	invert  =hex_wnd[i].GetConfig( 9);		// Maske fr's invertieren von Bytes
	sellock =hex_wnd[i].GetConfig(10);		// Die Auswahl auf das Ausgabeformat rastern


	hex_wnd[i^1].SetWidth(breite,nspace,space,adr_len,format,invert);
	hex_wnd[i^1].SetConfig(braster,raster,wert,sellock);

}

//*****************************************************************************
//*
//*		OnMarkChange
//*
//*****************************************************************************
//	nderung der Markierung
void CHexDoubleWnd::OnMarkChange(NMHDR *pNmHdr, LRESULT *pResult)
{
HEX_NMHDR	*hrd=(HEX_NMHDR*)pNmHdr;
MaxU		 temp;
MaxI		 adr;	
MaxI		 end;
MaxI		 cur;
int			 len;

	
	*pResult=1;


	if(hrd->sHdr.idFrom==HEX_ID1)
		{
		if(!hrd->iParam3)hex_wnd[1].DeleteSelection();
		else{
			   cur = hex_wnd[0].GetCursorAddr();
			if(cur!=hrd->iParam1)
				{
				temp			= hrd->iParam1;
				hrd->iParam1	= hrd->iParam2;
				hrd->iParam2	= temp;
				}
			
			if(hex_wnd[1].IsSelected())
				{
				adr  = hex_wnd[1].GetSelection(0,&len);
				end	 = adr-1;
				end	+= len;

				if(adr==hrd->iParam2 || end==hrd->iParam2)
					{
					hex_wnd[1].SetCursor(hrd->iParam1,0,1);
					return;
					}
				}
			
			hex_wnd[1].SetCursor(hrd->iParam2    );
			hex_wnd[1].SetCursor(hrd->iParam1,0,1);
			}
		}
	else{
		if(!hrd->iParam3)hex_wnd[0].DeleteSelection();
		else{
			   cur = hex_wnd[1].GetCursorAddr();
			if(cur!=hrd->iParam1)
				{
				temp		= hrd->iParam1;
				hrd->iParam1	= hrd->iParam2;
				hrd->iParam2	= temp;
				}
			
			if(hex_wnd[0].IsSelected())
				{
				adr  = hex_wnd[0].GetSelection(0,&len);
				end	 = adr-1;
				end	+= len;


				if(adr==hrd->iParam2 || end==hrd->iParam2)
					{
					hex_wnd[0].SetCursor(hrd->iParam1,0,1);
					return;
					}
				}
			
			hex_wnd[0].SetCursor(hrd->iParam2    );
			hex_wnd[0].SetCursor(hrd->iParam1,0,1);
			}
		}


	

}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CHexDoubleWnd::OnSetFocus(CWnd* Wnd)
{

	hex_wnd[focus_wnd].SetFocus();

}

//*****************************************************************************
//*
//*		SetMem
//*
//*****************************************************************************
// Weist dem Fenster einen Neuen Speicher Bereich zu
// Art:  Bit0  == 1  Speicher darf verndert werden
//             == 0  Speicher darf nicht verndert werden
// Art:  Bit1  == 1  Speicher wird vom Fenster freigegeben
//             == 0  Speicher wird nicht vom Fenster freigegeben
// Art:  Bit2  == 1  Nicht neuzeichen
// Art:  Bit3  == 1  Cursor und Scroll nicht Setzen
// Art:  Bit4  == 1  Keine neue Breite setzen
// Adresse	         Die Anzeige-Addresse des ersten Bytes (kein Offset!!)
// Ergibt die Lnge der letzten Speicherbereiches
CHexDoubleWnd::OffI CHexDoubleWnd::SetMem(int Nr,void *VMem,OffI Mem_laenge,AdrI Adresse,int Art)
{

	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].SetMem(VMem,Mem_laenge,Adresse,Art);

}


//*****************************************************************************
//*
//*		GetMem
//*
//*****************************************************************************
// Ergibt einen zeiger auf den aktuellen Speicher
// Wenn Laenge  != 0 ist wird dort die Lnge gespeichert.
// Wenn Adresse != 0 ist wird dort die Start-Adresse gespeichert.
unsigned char *CHexDoubleWnd::GetMem(int Nr,OffI *Laenge,AdrI *Adresse)
{

	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetMem(Laenge,Adresse);

}

//*****************************************************************************
//*
//*		SetBitSelection
//*
//*****************************************************************************
//	Einstellen der Bit-Marken
//	Marke	: Zeiger auf Bit-Feld
//	Size	: Lnge des Bitfelde in Bit (-1 fr die Speicherlnge)
//	Ergibt die Gre des Bit-Feldes
int	CHexDoubleWnd::SetBitSelection(int Nr,void *Marke,int Size)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].SetBitSelection(Marke,Size);
}

//*****************************************************************************
//*
//*		GetBitSelection
//*
//*****************************************************************************
//	Abfragen der Bit-Marken
//	Marke	: Zeiger auf Bit-Feld
//	Size	: Lnge des Bitfelde in Bit (-1 fr die Speicherlnge)
//	Ergibt die Gre des Bit-Feldes
void *CHexDoubleWnd::GetBitSelection(int Nr,int *Size)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetBitSelection(Size);
}

//*****************************************************************************
//*
//*		IsSelected
//*
//*****************************************************************************
//	Ergibt 1 wenn ein Bereich markiert ist
int CHexDoubleWnd::IsSelected(int Nr)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].IsSelected();
}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Ergibt 1 wenn ein Bereich markiert ist.
//	Ist Laenge!=0  so wird dort die Lnge der Marke gespeichert
//	Ist Mode==0	   so wird der Speicher-Offset zurckgegeben
//	Ist Mode!=0	   so wird die Adresse zurckgegeben
CHexDoubleWnd::MaxI CHexDoubleWnd::GetSelection(int Nr,int Mode,int *Laenge)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetSelection(Mode,Laenge);
}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Ergibt 1 wenn ein Bereich markiert ist.
//	Ist Start !=0  so wird dort der Start der Marke gespeichert
//	Ist Laenge!=0  so wird dort die Lnge der Marke gespeichert
//	Ist Mode==0	   so wird der Speicher-Offset zurckgegeben
//	Ist Mode!=0	   so wird die Adresse zurckgegeben
//	Ergibt 1 wenn ein Bereich markiert ist sonst 0
int CHexDoubleWnd::GetSelection(int Nr,void *Start,int Max,int *Laenge)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetSelection(Start,Max,Laenge);
}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Es wird der Markierte Bereich nach Mem kopiert 
//	Max ist die Maximale lnge von Mem
//	Ist Laenge!=0  so wird dort die Lnge der Marke gespeichert
//	Ergibt die Anzahl der kopierten Bytes
int CHexDoubleWnd::GetSelection(int Nr,MaxI *Start,int *Laenge,int Mode)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetSelection(Start,Laenge,Mode);
}


//*****************************************************************************
//*
//*		Select
//*
//*****************************************************************************
// Markiere den Bereich Art von Start mit Laenge
// Wenn Laenge <= 0 dann wird die Markierungen gelscht
// Wenn Art!= -1 dann die nchste Freie Markierungen gesucht
// Wenn Art!= -2 dann werden alle Markierungen gelscht
// Ergibt die Bereichs Nummer fr den Bereich
//	      bzw. HEX_SLOT_COUNT wenn kein bereich vorhanden ist .
int CHexDoubleWnd::Select(int Nr,int Art,OffI Start,OffI Laenge)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].Select(Art,Start,Laenge);
}

//*****************************************************************************
//*
//*		MoveTo
//*
//*****************************************************************************
//	Der Cursor wird mit einem Dialog auf eine neue Adresse gesetzt
//	Ist Addr!=-1 so wird der Dialog auf Addr gesetzt
//	Ergibt die Zieladresse bzw. -1 bei einem Abbbruch
CHexDoubleWnd::AdrI CHexDoubleWnd::MoveTo(int Nr,AdrI Addr)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].MoveTo(Addr);
}

//*****************************************************************************
//*       
//*		GetCursorMem
//*       
//*****************************************************************************
//	Es wird der Bereich auf den der Cursor steht nach Mem kopiert 
//	Anz ist die Anzahl der zu kopierenden Bytes
//	Ergibt die Anzahl der kopierten Bytes
int CHexDoubleWnd::GetCursorMem(int Nr,void *Mem,int Anz)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetCursorMem(Mem,Anz);
}

//*****************************************************************************
//*       
//*		GetSelectedMem	  
//*       
//*****************************************************************************
//	Es wird der Bereich der Marke nach Mem kopiert 
//	Anz ist die maximale Anzahl der zu kopierenden Bytes
//	Ergibt die Anzahl der kopierten Bytes
int CHexDoubleWnd::GetSelectedMem(int Nr,void *Mem,int Anz)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetSelectedMem(Mem,Anz);
}

//*****************************************************************************
//*
//*		GetScroll  
//*
//*****************************************************************************
//	Ergibt die Adresse bzw. den Offset der linken oberen Fensterecke
//	Ist Mode==0		wird der Speicher-Offset zurckgegeben
//	Ist Mode!=0		wird die Adresse zurckgegeben
CHexDoubleWnd::MaxI CHexDoubleWnd::GetScroll(int Nr,int Mode)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetScroll(Mode);
}

//*****************************************************************************
//*
//*		GetCursor  
//*
//*****************************************************************************
//	Ergibt die alktuelle Cursor-Adresse bzw. den Offset des Cursors
//	Ist ein Bereich markiert so wird die niedrigste Addresse der Marke zukgegeben
//	Ist Mode==0		wird der Speicher-Offset zurckgegeben
//	Ist Mode!=0		wird die Adresse zurckgegeben
CHexDoubleWnd::MaxI CHexDoubleWnd::GetCursor(int Nr,int Mode)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetCursor(Mode);
}


//*****************************************************************************
//*
//*		GetAddress
//*
//*****************************************************************************
//	Ergibt die Adresse des ersten Bytes  
CHexDoubleWnd::AdrI CHexDoubleWnd::GetAddress(int Nr)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetAddress();
}


//*****************************************************************************
//*
//*		GetLength
//*
//*****************************************************************************
CHexDoubleWnd::OffI CHexDoubleWnd::GetLength(int Nr)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetLength();
}

//*****************************************************************************
//*
//*		GetViewSize
//*
//*****************************************************************************
// Hole die Anzahl der angezeigen Bytes auf einer Seite
int CHexDoubleWnd::GetViewSize(int Nr)									
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].GetViewSize();
}

//*****************************************************************************
//*
//*		SetAddress
//*
//*****************************************************************************
//  Setzt die Basis Anzeiger Adresse des Speicher Bereiches
CHexDoubleWnd::AdrI CHexDoubleWnd::SetAddress(int Nr,AdrI Adresse)
{
	if(Nr<0 || Nr>1)return 0;
	return hex_wnd[Nr].SetAddress(Adresse);
}

//*****************************************************************************
//*
//*		DeleteSelection
//*
//*****************************************************************************
void CHexDoubleWnd::DeleteSelection()
{
	hex_wnd[0].DeleteSelection();
	hex_wnd[1].DeleteSelection();
}

//*****************************************************************************
//*
//*		SetScroll
//*
//*****************************************************************************
//  Setzt die Adresse der linken oberen Ecke
//	Ist Mode==0		ist Adresse ein  Speicher-Offset
//	Ist Mode!=0		ist Adresse eine Speicher-Adresse
void CHexDoubleWnd::SetScroll(MaxI Adresse,int Mode)
{
	hex_wnd[0].SetScroll(Adresse,Mode);
	hex_wnd[1].SetScroll(Adresse,Mode);
}

//*****************************************************************************
//*
//*		SetSelection
//*
//*****************************************************************************
// Setzt die eine Marken Position
//	Ist Mode==0		ist Adresse ein  Speicher-Offset
//	Ist Mode!=0		ist Adresse eine Speicher-Adresse
//			Offset = Adresse-mem_start;
void CHexDoubleWnd::SetSelection(MaxI Adresse,int Mode)
{
	hex_wnd[0].SetSelection(Adresse,Mode);
	hex_wnd[1].SetSelection(Adresse,Mode);
}

//*****************************************************************************
//*
//*		SetCursor
//*
//*****************************************************************************
//	Setzt den Cursor auf die angegebene Adresse
//	Ist Mode==0		ist Adresse ein  Speicher-Offset
//	Ist Mode!=0		ist Adresse eine Speicher-Adresse
//			Offset = Adresse-=mem_start;
void CHexDoubleWnd::SetCursor(MaxI Adresse,int Mode)
{
	hex_wnd[0].SetCursor(Adresse,Mode);
	hex_wnd[1].SetCursor(Adresse,Mode);
}

//*****************************************************************************
//*
//*		OnCppCopy
//*
//*****************************************************************************
void CHexDoubleWnd::OnCppCopy()
{
	hex_wnd[focus_wnd].OnCppCopy();
}


//*****************************************************************************
//*
//*		OnChecksum
//*
//*****************************************************************************
void CHexDoubleWnd::OnChecksum()
{
	hex_wnd[focus_wnd].OnChecksum();
}


//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CHexDoubleWnd::OnCopy()
{
	hex_wnd[focus_wnd].SelectionCopy();
}


//*****************************************************************************
//*
//*		OnSuchenView
//*
//*****************************************************************************
void CHexDoubleWnd::OnSuchenView()
{
	hex_wnd[focus_wnd].FindView();
}


//*****************************************************************************
//*
//*		OnMoveTo
//*
//*****************************************************************************
void CHexDoubleWnd::OnMoveTo()
{
	hex_wnd[focus_wnd].OnMoveTo();
}


//*****************************************************************************
//*
//*		OnHexConvert
//*
//*****************************************************************************
void CHexDoubleWnd::OnHexConvert()
{
	hex_wnd[focus_wnd].OnHexConvert();
}


//*****************************************************************************
//*
//*		OnConfigView
//*
//*****************************************************************************
void CHexDoubleWnd::OnConfigView()
{
	hex_wnd[focus_wnd].ConfigView();
}


//*****************************************************************************
//*
//*		OnSuchenWeiter
//*
//*****************************************************************************
void CHexDoubleWnd::OnSuchenWeiter()
{
	hex_wnd[focus_wnd].FindNext();
}


//*****************************************************************************
//*
//*		OnSuchenMarke
//*
//*****************************************************************************
void CHexDoubleWnd::OnSuchenMarke()
{
	hex_wnd[focus_wnd].FindSelection();
}


//*****************************************************************************
//*
//*		OnMenuSelection
//*
//*****************************************************************************
void CHexDoubleWnd::OnMenuSelection(CCmdUI *pCmdUI)
{
	hex_wnd[focus_wnd].OnMenuSelection(pCmdUI);
}


//*****************************************************************************
//*
//*		OnMenuFind
//*
//*****************************************************************************
void CHexDoubleWnd::OnMenuFind(CCmdUI *pCmdUI)
{
	hex_wnd[focus_wnd].OnMenuFind(pCmdUI);
}


//*****************************************************************************
//*
//*		SetFlags
//*
//*****************************************************************************
//	Stellt die Flags ein.
//	Es werden nur die Flags gesetzt deren Bits in Mask auf eins sind.
//	Ergibt die alten Flags
int	CHexDoubleWnd::SetFlags(int Flags,int Mask)
{
int	old;

	old=flags;

	flags&=~Mask;
	flags|= Flags&Mask;


	
	if(((old^flags)&HDW_HORZ) && IsWindow(m_hWnd))
		{
		OnSize(0,view_x,view_y);
		}


return old;
}

//*****************************************************************************
//*
//*		FindText
//*
//*****************************************************************************
//	Sucht im Bereich Start bis +Laenge nach Text-Angabe
//  Form:   [Bereichs-Lnge]                    /00
//          [Art-Byte]:[Lnge]   [/G][/B] :Hex-Dump /00
//			[Art-Byte]:[Lnge]   [/G][/B] :Hex-Dump /00 ...
//          /00
//          /G       :  fr Gro/Kleinschreibung ignorieren
//          /B       :  fr Modorola Format
//          Art-Byte :  'D'-Dezimal  'H'-Hexadez. 'B'=Binr 'T'=Text 'U'=Hex-Dump 'M'=Masken-Dump
//
//	Bei Masken-Dumps muss Lnge halbiert werden
//  Ist Laenge kleiner 0 so wird nach unten gesucht.
//  Markieren gibt an ob der Bereich markiert werden soll wenn
//  er gefunden wird;
//	Wnd	:	Nummer des Fenster (0,1 , -1=aktives Fenster)
//  Ergibt die Offsetadresse in Mem bzw. -1 wenn nichts gefunden wurde
CHexDoubleWnd::OffI CHexDoubleWnd::FindText(char *Text,OffI Start,OffI Laenge,int Markieren,int Wnd)
{

	if(Wnd&~1)Wnd=focus_wnd;

	return hex_wnd[Wnd].FindText(Text,Start,Laenge,Markieren);

}


//*****************************************************************************
//*
//*		SetActiveWnd
//*
//*****************************************************************************
//	Ergibt das zuletzt aktive Fenster
int	CHexDoubleWnd::SetActiveWnd(int Wnd)
{
int old;

	
	old=focus_wnd;
	hex_wnd[Wnd&1].SetFocus();	

return old;
}

//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
//	Setzt die Titeltexte der Fenster
//	Wenn beide Titel 0 sind werden die Texte ausgeblendet
//	Nr		: Ist die Fensternummer
//	Text	: Zeiger auf Titeltext
void CHexDoubleWnd::SetTitle(int Nr,const char *Text)
{
int		len,on;


	if(titel[Nr])
		{
		delete titel[Nr];
		titel[Nr]=0;
		}

	on = (titel[0] || titel[1])? 1:0;

	if(Text)
		{
		len = strlen(Text)+1;
		titel[Nr] = new char [len];
		memcpy(titel[Nr],Text,len);
		}
	else{
		Text="";
		}

	if(IsWindow(title_wnd[Nr].m_hWnd))
		{
		title_wnd[Nr].SetWindowText(Text);
		}

	on ^= (titel[0] || titel[1])? 1:0;

	if(on)OnSize(0,view_x,view_y);

}

//*****************************************************************************
//*
//*		OnColorView
//*
//*****************************************************************************
void CHexDoubleWnd::OnColorView()
{
	hex_wnd[0].ColorView();
}

//*****************************************************************************
//*
//*		ColorView
//*
//*****************************************************************************
int	CHexDoubleWnd::ColorView()
{
return hex_wnd[0].ColorView();
}

//*****************************************************************************
//*
//*		OnFontView
//*
//*****************************************************************************
void CHexDoubleWnd::OnFontView()
{
	hex_wnd[0].FontView();
}

//*****************************************************************************
//*
//*		FontView
//*
//*****************************************************************************
int	CHexDoubleWnd::FontView()
{
return hex_wnd[0].FontView();
}


//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CHexDoubleWnd::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
int		iFlags;
LPCTSTR	pPath;
CMenu	sMenu;
CPoint	sPos;


	sPos = sPoint;
	ScreenToClient(&sPos);

	if(flags&HDW_HORZ)
		{
		copy_index = (sPos.y<view_y/2)? 0:1;
		}
	else{
		copy_index = (sPos.x<view_x/2)? 0:1;
		}
	
	pPath   = file_path[copy_index];
	iFlags	= (!*pPath)? MF_GRAYED:0;

	sMenu.CreatePopupMenu();
	sMenu.AppendMenu(MF_STRING|iFlags,ID_COPYPATH    ,_T("Pfad kopieren" ));
	sMenu.AppendMenu(MF_STRING|iFlags,ID_START_EDITOR,_T("HEX-Editor starten"));
	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnCopyPath
//*
//*****************************************************************************
void CHexDoubleWnd::OnCopyPath()
{

	if(file_path[copy_index].IsEmpty())return;


	SetClipboardText(file_path[copy_index]);


}

//*****************************************************************************
//*
//*		OnStartEditor
//*
//*****************************************************************************
void CHexDoubleWnd::OnStartEditor()
{
TCHAR		path[MAX_PATH];
TCHAR		text[24];
LPCTSTR		editor;
CStartProg	start;
unsigned	addr;


	if(file_path[copy_index].IsEmpty())return;

	for(;;)
		{
		GetExePath(path);
		AddFileName(path,"HexEditor.exe",sizeof(path));
		editor=path;
		if(ExistFile(editor)==1)break;

		GetExePath(path);
		AddFileName(path,"..\\HexEditor\\HexEditor.exe",sizeof(path));
		editor=path;
		if(ExistFile(editor)==1)break;

		editor="D:\\MyProjects\\HexEditor\\Release\\HexEditor.exe";
		if(ExistFile(editor)==1)break;

		return;
		}

	addr = hex_wnd[copy_index].GetScroll();

	if(addr>11)
		{
		_stprintf(text,_T("-s:%u"),addr-11);
		start.SetParam(text);
		}

	start.SetParam(file_path[copy_index]);
	start.SetFilename(editor);
	start.Start(CSP_NOWAIT);
	start.WaitForInit();


}
