//*****************************************************************************
//*
//*
//*		Klasse  CHexDoubleWnd
//*
//*
//*****************************************************************************
#if !defined(AFX_HEXDOUBLEWND_H__88348888_SXDA_5341_9973_144553540000__INCLUDED_)
#define      AFX_HEXDOUBLEWND_H__88348888_SXDA_5341_9973_144553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include	"HexWnd.h"

#define 	HDW_VERT			0x0000			// Vertical anordnen	
#define 	HDW_HORZ			0x0001			// Horizontal anordnen	


//*****************************************************************************
//*
//*		CHexDoubleWnd
//*
//*****************************************************************************
class CHexDoubleWnd	: public CWnd
{
public:

	typedef	CHexWnd::MaxI		MaxI;
	typedef	CHexWnd::OffI		OffI;
	typedef	CHexWnd::AdrI		AdrI;
	typedef	CHexWnd::MaxU		MaxU;
	typedef	CHexWnd::OffU		OffU;
	typedef	CHexWnd::AdrU		AdrU;


	CHexDoubleWnd(int Art=0);
   ~CHexDoubleWnd();

	virtual BOOL CHexDoubleWnd::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID=0xFFFF);

	OffI			SetMem			(int Nr,void *VMem,OffI Mem_laenge,AdrI Adresse=0,int Art=0);
	unsigned char  *GetMem			(int Nr,OffI *Laenge=0,AdrI *Adresse=0);
	int				SetBitSelection	(int Nr,void *Marke,int Size=-1);
	void           *GetBitSelection (int Nr,int  *Size=0);
	int				IsSelected		(int Nr);							// Ergibt ob eitwas markiert ist
	MaxI   			GetSelection	(int Nr,int   Mode  =0            ,int *Laenge=0);
	int	   			GetSelection	(int Nr,void *Start,  int  Max    ,int *Laenge=0);
	int	   			GetSelection	(int Nr,MaxI *Start,               int *Laenge=0,int Mode=0);
	int	   			Select			(int Nr,int   Art =-1,OffI Start=0,OffI Laenge=0);
	AdrI   			MoveTo			(int Nr,AdrI  Addr=-1);
	int	   			GetCursorMem	(int Nr,void *Mem,int Anz);			// Speicher bei Cursor kopieren
	int	   			GetSelectedMem	(int Nr,void *Mem,int Anz);			// Speicher der Marke  kopieren
	MaxI   			GetScroll		(int Nr,int   Mode=0);				// Hole Addresse/Offset der linken oberen Ecke
	MaxI   			GetCursor		(int Nr,int   Mode=0);				// Hole Cursor Addrese/Offset
	AdrI   			SetAddress		(int Nr,AdrI  Adresse);				// Setze Basis Anzeige Addrese
	AdrI   			GetAddress		(int Nr);							// Hole Basis  Anzeige Addrese
	OffI   			GetLength		(int Nr);							// Hole Speicherlnge
	int				GetViewSize     (int Nr);							// Hole die Anzahl der angezeigen Bytes auf einer Seite
	int	   			GetFlags    	();
	int	   			SetFlags    	(int Flags,int Mask=0xFFFF);
	void			SetTitle		(int Nr,const char *Text);
	void			SetFilePath     (int Nr,const char *Text);

	void   			SetCursor	 	(MaxI Adresse,int Mode=0);			// Setze Cursor auf Anzeige Addrese
	void   			SetScroll	 	(MaxI Adresse,int Mode=0);			// Setze Addresse der linken oberen Ecke
	void   			SetSelection	(MaxI Adresse,int Mode=0);			// Setze Marke  auf Anzeige Addrese
	void   			DeleteSelection	();									// Marke lschen
 
	OffI			FindText		(char *Text,OffI Start=0,OffI Laenge=0x40000000,int Markieren =0,int Wnd=-1);

	int				FontView();
	int				ColorView();
	inline int		GetActiveWnd();
	int				SetActiveWnd(int Wnd);

	//{{AFX_VIRTUAL(CFileCompareView)
	public:
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CFileCompareView)	
	afx_msg void OnContextMenu(CWnd *pWnd,CPoint sPoint);
	afx_msg void OnSize(UINT nType,int cx, int cy);
	afx_msg void OnSetFocus(CWnd *pWnd);
	afx_msg	void OnCppCopy();
	afx_msg	void OnChecksum();
	afx_msg	void OnStartEditor();
	afx_msg	void OnCopyPath();
	afx_msg	void OnCopy();
	afx_msg	void OnConfigView();
	afx_msg	void OnSuchenView();
	afx_msg	void OnSuchenWeiter();
	afx_msg	void OnSuchenMarke();
	afx_msg	void OnMoveTo();
	afx_msg	void OnHexConvert();
	afx_msg	void OnColorView();
	afx_msg	void OnFontView();
	afx_msg	void OnPaint();
	//}}AFX_MSG

	afx_msg void OnSetFocusChange	(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnKillFocusChange	(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnConfigChange		(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnScrollChange		(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnMarkChange		(NMHDR *pNmHdr, LRESULT *pResult);

public:
	afx_msg	void OnMenuSelection (CCmdUI *pCmdUI);
	afx_msg	void OnMenuFind(CCmdUI *pCmdUI);

private:



//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

protected:

	DECLARE_MESSAGE_MAP()

	static CString	class_name;

	int				copy_index;					// Index fr's Kopiern
	CString			file_path[2];				// Dateipfade
	CHexWnd			hex_wnd[2];					// Fensterklassen
	CStatic			title_wnd[2];				// Fenster fr Titeltexte
	DWORD			flags;						// Falgs fr die Fenster Erstellung
	int				focus_wnd;					// Nummer des Fensters mit dem Focus
	int				view_x,view_y;				// Fensterauflsung
	char		   *titel[2];					// Zeiger auf Titel-Texte	
	
};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline void	CHexDoubleWnd::SetFilePath   (int Num,const char *Text){file_path[Num]=Text;}
inline int  CHexDoubleWnd::GetActiveWnd(){return focus_wnd;}
inline int	CHexDoubleWnd::GetFlags(){return flags;}

//{{AFX_INSERT_LOCATION}}



#endif

