//*****************************************************************************
//*
//*
//*		MainFrm.cpp : Implementierung der Klasse CMainFrame
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "FileCompare.h"
#include "MainFrm.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_HELP						,OnHelp)
	ON_COMMAND(ID_FIXWINDOW					,OnFixWindow)
	ON_COMMAND(ID_STATUS_BAR_FLAT			,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_FIXWINDOW		,OnFixWindowUI)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT	,OnFlatBarUI)
	//}}AFX_MSG_MAP
	ON_STATUSBAR()
	ON_MENUICON()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_INDICATOR_NUM,
};

STATUSBAR_PROC(CMainFrame)
MENUICON_PROC(CMainFrame)


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
// CMainFrame Konstruktion/Zerstrung
CMainFrame::CMainFrame()
{
CRegKeys	sKey;


	m_bFlatMode		= TRUE;
	m_bWindowFixed	= FALSE;

	sKey.Open();
	sKey.Up("Settings");
	sKey.Get(m_bFlatMode,"FlatMode");

}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up("Settings");
	sKey.Set(m_bFlatMode,"FlatMode");

}


//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
{
DWORD	dwStyle;
int		iSizeX;



	if(CFrameWnd::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}


	iSizeX = GetSystemMetrics(SM_CXICON);

	if(iSizeX>32 && !IsZoomed() && !IsIconic() && pCreateStruct->cx==0x80000000 && pCreateStruct->cy==0x80000000)
		{
		CSize	sSize(60,0);
		SizeWindow(this,&sSize,TRUE);
		}



	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	if(!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	// ZU ERLEDIGEN: Entfernen, wenn Sie keine QuickInfos oder variable Symbolleiste wnschen
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC | CBRS_ALIGN_TOP);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit(IDR_MAINFRAME);


return 0;
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &sCreate)
{

	if(!CFrameWnd::PreCreateWindow(sCreate))
		{
		return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
// CMainFrame Diagnose
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif


//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode=(dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}


}

//*****************************************************************************
//*
//*		OnHelp
//*
//*****************************************************************************
void CMainFrame::OnHelp()
{
CDialog	 sDlg(IDD_HELPDLG);

	sDlg.DoModal();

}



//*****************************************************************************
//*
//*		OnFixWindowUI
//*
//*****************************************************************************
void CMainFrame::OnFixWindowUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bWindowFixed);
}

//*****************************************************************************
//*
//*		OnFixWindow
//*
//*****************************************************************************
void CMainFrame::OnFixWindow()
{
	m_bWindowFixed = !m_bWindowFixed;
	SetWindowPos((m_bWindowFixed)? &wndTopMost:&wndNoTopMost,0,0,0,0,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
}
