//*****************************************************************************
//*
//*
//*		OpenDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	Copyright  2006	Anton Zechner
//
#include	"StdAfx.h"
#include	"FileCompare.h"
#include	"AfxUtility.h"
#include	"OpenDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif



BEGIN_MESSAGE_MAP(COpenDlg, CDialog)
	//{{AFX_MSG_MAP(COpenDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON1, OnPath1)
	ON_BN_CLICKED(IDC_BUTTON2, OnPath2)
	ON_MESSAGE(OPEN_ID,OnOpenId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


HICON	COpenDlg::m_hIcon = 0;



//*****************************************************************************
//*
//*		Dialogfeld COpenDlg
//*
//*****************************************************************************
COpenDlg::COpenDlg(CWnd *pParent )	: CDialog(COpenDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COpenDlg)
	m_sPath1 = _T("");
	m_sPath2 = _T("");
	m_bIntelAuto = FALSE;
	m_bIntel1 = FALSE;
	m_bIntel2 = FALSE;
	//}}AFX_DATA_INIT
	m_bEnableReceive=FALSE;
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COpenDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenDlg)
	DDX_ComboEx(pDX, IDC_COMBO1, m_sPath1);
	DDX_ComboEx(pDX, IDC_COMBO2, m_sPath2);
	DDX_Check(pDX, IDC_CHECK1, m_bIntelAuto);
	DDX_Check(pDX, IDC_CHECK2, m_bIntel1);
	DDX_Check(pDX, IDC_CHECK3, m_bIntel2);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL COpenDlg::OnInitDialog()
{
CRegKeys	sKey;
CRect		sRect;
int			iXpos,iYpos;



	if(!m_hIcon)
		{
		m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
		}

	SetIcon(m_hIcon,TRUE );
	SetIcon(m_hIcon,FALSE);


	ComboBoxLoad(this,IDC_COMBO1,"File1","Software\\AZ\\FileCompare");
	ComboBoxLoad(this,IDC_COMBO2,"File2","Software\\AZ\\FileCompare");


	CDialog::OnInitDialog();

	if(m_bEnableReceive)
		{
		sKey.Open();
		GetWindowRect(&sRect);

		iXpos=sRect.left;
		iYpos=sRect.top;

		sKey.Get(iXpos,"OpenDialogX");
		sKey.Get(iYpos,"OpenDialogY");

		if(iXpos<GetSystemMetrics(SM_CXSCREEN)-8)
		if(iYpos<GetSystemMetrics(SM_CYSCREEN)-8)
			{
			::MoveWindow((CWnd*)this,iXpos,iYpos);
			}

		BringWindowToTop();
		SetWindowLong(m_hWnd,GWL_USERDATA,OPEN_USER);
		}

	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	SetButtonBitmap(this,IDC_BUTTON2,IDB_OPEN);

	SubclassComboBox(this,IDC_COMBO1,SCB_DROPFILE);
	SubclassComboBox(this,IDC_COMBO2,SCB_DROPFILE);


return TRUE;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void COpenDlg::OnDestroy()
{
	CDialog::OnDestroy();

	DelButtonBitmap(this,IDC_BUTTON1);
	DelButtonBitmap(this,IDC_BUTTON2);

}


//*****************************************************************************
//*
//*		UpdateData
//*
//*****************************************************************************
void COpenDlg::OnOK()
{
CRegKeys	sKey;
CRect		sRect;
int			iXpos,iYpos;


	UpdateData();

	ComboBoxSave(this,IDC_COMBO1,"File1","Software\\AZ\\FileCompare");
	ComboBoxSave(this,IDC_COMBO2,"File2","Software\\AZ\\FileCompare");


	if(m_bEnableReceive)
		{
		sKey.Open();

		GetWindowRect(&sRect);

		iXpos=sRect.left;
		iYpos=sRect.top;

		sKey.Set(iXpos,"OpenDialogX");
		sKey.Set(iYpos,"OpenDialogY");
		}


	CDialog::OnOK();

}


//*****************************************************************************
//*
//*		OnPath1
//*
//*****************************************************************************
void COpenDlg::OnPath1()
{

	UpdateData();

	CFileDialog	sDlg(TRUE,"*.*",m_sPath1,OFN_EXPLORER|OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,"Alle Dateien|*.*|");
	if(sDlg.DoModal()!=IDOK)return;

	m_sPath1=sDlg.GetPathName();

	UpdateData(FALSE);

}


//*****************************************************************************
//*
//*		OnPath2
//*
//*****************************************************************************
void COpenDlg::OnPath2()
{

	UpdateData();

	CFileDialog	sDlg(TRUE,"*.*",m_sPath2,OFN_EXPLORER|OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,"Alle Dateien|*.*|");
	if(sDlg.DoModal()!=IDOK)return;

	m_sPath2=sDlg.GetPathName();

	UpdateData(FALSE);

}


//*****************************************************************************
//*
//*		OnOpenId
//*
//*****************************************************************************
//	Diese Nachricht wird von einem anderen Program gesendet
void COpenDlg::OnOpenId(WPARAM wParam,LPARAM lParam)
{
CRegKeys	sKey;
CRect		sRect;
int			iXpos,iYpos;



	if(!m_bEnableReceive)return;


	sKey.Open();

	GetWindowRect(&sRect);

	iXpos=sRect.left;
	iYpos=sRect.top;

	sKey.Set(iXpos,"OpenDialogX");
	sKey.Set(iYpos,"OpenDialogY");


	OnCancel();
}
